<?php
/**
*
* @package extender: core and template event listeners constructor
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\extender\acp;

class extender_module
{
	protected $config;
	protected $cache;
	protected $phpbb_container;
	protected $config_text;
	protected $request;
	protected $template;
	protected $user;

	public	$u_action;

	function main($id, $mode)
	{
		global $cache, $config, $config_text, $db, $user, $auth, $template, $request;
		global $phpbb_root_path, $phpEx, $phpbb_admin_path, $phpbb_container;

		$this->config = $config;
		$this->config_text = $config_text;
		$this->cache = $cache;
		$this->request = $request;
		$this->template = $template;
		$this->user = $user;

		$this->page_title = 'ACP_EXTENDER';
		$this->tpl_name = 'acp_extender';
		
		$submit = (isset($_POST['submit'])) ? true : false;
		$form_key = 'config_extender';
		add_form_key($form_key);
		$error = array();

		$realpath = realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'extender'.DIRECTORY_SEPARATOR;
		$admpath = $realpath.'adm'.DIRECTORY_SEPARATOR.'style'.DIRECTORY_SEPARATOR.'event';
		$allpath = $realpath.'styles'.DIRECTORY_SEPARATOR.'all'.DIRECTORY_SEPARATOR.'template'.DIRECTORY_SEPARATOR.'event';

		if ( !is_writable($admpath) )
		{
			$error[] = sprintf($user->lang['ACP_EXTENDER_DIRECTORY_NOT_WRITABLE'], $admpath);
		}
		if ( !is_writable($allpath) )
		{
			$error[] = sprintf($user->lang['ACP_EXTENDER_DIRECTORY_NOT_WRITABLE'], $allpath);
		}
		if ( !is_writable(sys_get_temp_dir()) )
		{
			$error[] = sprintf($user->lang['ACP_EXTENDER_DIRECTORY_NOT_WRITABLE'], sys_get_temp_dir());
		}

		$admpath .= DIRECTORY_SEPARATOR;
		$allpath .= DIRECTORY_SEPARATOR;

		$acp_overall_footer_after = $admpath . 'acp_overall_footer_after.html';
		$overall_footer_body_after = $allpath . 'overall_footer_body_after.html';

		if ( file_exists($acp_overall_footer_after) && !is_writable($acp_overall_footer_after) )
		{
			phpbb_chmod($acp_overall_footer_after,CHMOD_READ|CHMOD_WRITE);
		}
		if ( file_exists($overall_footer_body_after) && !is_writable($overall_footer_body_after) )
		{
			phpbb_chmod($overall_footer_body_after,CHMOD_READ|CHMOD_WRITE);
		}

		if ( !is_writable($acp_overall_footer_after) )
		{
			$error[] = sprintf($user->lang['ACP_EXTENDER_FILE_NOT_WRITABLE'], $acp_overall_footer_after);
		}
		if ( !is_writable($overall_footer_body_after) )
		{
			$error[] = sprintf($user->lang['ACP_EXTENDER_FILE_NOT_WRITABLE'], $overall_footer_body_after);
		}

		$locktypes = array('Core','Template');

		$locked = false;
		$unlocked = false;
		$listing = '';
		$lockfiles = '';
		foreach ( $locktypes as $locktype )
		{
			$lockfile = sys_get_temp_dir().DIRECTORY_SEPARATOR.'Extender_'.dechex(crc32($this->config['cookie_domain'].$this->config['cookie_name'])).'_'.$locktype.'.lock';
			if ( @file_exists($lockfile) )
			{
				$listing .= '<br /><br />'.file_get_contents($lockfile);
				if ( $submit )
				{
					@unlink($lockfile);
					if ( @file_exists($lockfile) )
					{
						$locked = true;
					}
					else
					{
						$unlocked = true;
					}
				}
				else
				{
					$locked = true;
				}
				if ( $locked )
				{
					$lockfiles .= '<br />'.htmlspecialchars($lockfile);
				}
			}
		}
		if ( $locked )
		{
			$error[] = $user->lang('ACP_EXTENDER_LOCKED').'sys_get_tmp_dir/'.basename($lockfiles).'<br />'.$listing.'<b>'.($unlocked ? ('<br /><br />'.$user->lang('ACP_EXTENDER_UNLOCKED')) : '').'</b>';
		}


		$display_vars = array(
			'title'	=> 'ACP_EXTENDER',
			'vars'	=> array(
				'legend1'				=> 'ACP_EXTENDER_CORE_CONSTRUCTOR',
				'extender_core_on'			=> array('lang' => 'ACP_EXTENDER_CORE_ON', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'extender_core'				=> array('lang' => 'ACP_EXTENDER_CORE', 'validate' => 'text', 'type' => 'textarea:30:40', 'explain' => true),

				'legend2'				=> 'ACP_EXTENDER_TEMPLATE_CONSTRUCTOR',
				'extender_template_on'		=> array('lang' => 'ACP_EXTENDER_TEMPLATE_ON', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'extender_template'			=> array('lang' => 'ACP_EXTENDER_TEMPLATE', 'validate' => 'text', 'type' => 'textarea:50:40', 'explain' => true),

				'legend3'				=> 'ACP_EXTENDER_MODES',
				'extender_debug'			=> array('lang' => 'ACP_EXTENDER_DEBUG', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'extender_debug_warnings'	=> array('lang' => 'ACP_EXTENDER_DEBUG_WARNINGS', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				
				'legend4'				=> 'ACP_EXTENDER_EDITOR',
				'extender_codemirror'		=> array('lang' => 'ACP_EXTENDER_CODEMIRROR', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'extender_cm_path'			=> array('lang' => 'ACP_EXTENDER_CM_PATH', 'validate' => 'string',	'type' => 'text:40:40', 'explain' => true),
				'extender_cm_script'		=> array('lang' => 'ACP_EXTENDER_CM_SCRIPT', 'validate' => 'text', 'type' => 'textarea:30:40', 'explain' => true),

				'legend5'				=> 'ACP_SUBMIT_CHANGES',
			),
		);
						
		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		if (!function_exists('display_custom_bbcodes'))
		{
			include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
		}

		if (!class_exists('parse_message'))
		{
			include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		}
		
		$config_text = $phpbb_container->get('config_text');

		$extender_config_text_keys = array();
		$extender_config_keys = array();

		foreach ( $display_vars['vars'] as $varname => $vararray )
		{
			if ( !is_array($vararray) ) continue;
			if ( $vararray['validate'] == 'text' )
			{
				$extender_config_text_keys[] = $varname;
			}
			else
			{
				$extender_config_keys[] = $varname;
			}
		}

		$extender_config_text_values = array();
		foreach ( $extender_config_text_keys as $key => $value)
		{
			$data = $config_text->get_array(array($value));
			$extender_config_text_values[$value] = $data[$value];
		}

		$extender_config_values = array();
		foreach ( $extender_config_keys as $key => $value)
		{
			$extender_config_values[$value] = $this->config[$value];
		}

		if (!sizeof($error) && $this->request->is_set_post('submit'))
		{
			if (!check_form_key($form_key))
			{
				$error[] = $user->lang('FORM_INVALID');
			}
			else
			{
				foreach ( $extender_config_text_values as $key => $value)
				{
					$new_value = $request->variable(array('config',$key),'',true);
					if ( (string) $new_value !== (string) $value )
					{
						$value = $extender_config_text_values[$key] = $new_value;
						if ( ($key == 'extender_cm_script') && empty($value) )
						{
							$value = $extender_config_text_values[$key] = htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'extender'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'cm_script.inc'));
						}
						$config_text->set_array(array(
							$key => $value,
						));
					}
				}

				$extender_core = htmlspecialchars_decode($extender_config_text_values['extender_core']);
				if ( !empty($extender_core)
				  && preg_match_all('/<!--\s*EVENT\s*([-|\d]\d{1,}|)\s*(.*?)\s*-->(.*?)<!--\s*ENDEVENT\s*-->/su',$extender_core,$matches,PREG_OFFSET_CAPTURE)
				)
				{
					$core_events = array();
					for ( $i=0,$eindex=0; $i<count($matches[0]); $i++ )
					{
						$priority = empty($matches[1][$i][0]) ? 0 : ((int) $matches[1][$i][0]);
						$names = explode(',',str_replace(array(' ',';','|'),array('',',',','),$matches[2][$i][0]));
						foreach( $names as $name )
						{
							if ( empty($name) ) continue;
							if ( !preg_match('/^[a-z0-9_\.]+$/',$name) ) continue;
							$core_events[$eindex] = array(
								'name'					=> $name,
								'priority'				=> $priority,
								'exec_source'			=> $matches[3][$i][0],
								'exec_source_addlines'	=> substr_count($extender_core,"\n",0,$matches[3][$i][1]),
								'eval'					=> htmlspecialchars_decode($matches[3][$i][0])
							);
							$eindex++;
						}
					}
					$core_events[$eindex] = array(
						'time'	=> time(),
					);
					$config_text->set_array(array(
						'extender_core_prepared' => serialize($core_events),
					));
					$config->set('extender_core_crc32',crc32($extender_config_text_values['extender_core']));
				}

				foreach ( $extender_config_values as $key => $value)
				{
					$new_value = $request->variable(array('config',$key),'',true);
					if ( (string) $new_value !== (string) $value )
					{
						$value = $extender_config_values[$key] = $new_value;
						$config->set($key,$value);
					}
				}

				$extender_template = htmlspecialchars_decode($extender_config_text_values['extender_template']);

				$te = false;
				if ( preg_match_all('/<!--\s*ALLEVENTS\s*-->(.*?)<!--\s*ENDALLEVENTS\s*-->/su',$extender_template,$matches) )
				{
					foreach ( $matches[1] as $match )
					{
						$match = trim($match);
						if ( empty($match) ) $te = true;
					}
				}

				if ( $te )
				{
					$dirs = array(
						realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'styles'.DIRECTORY_SEPARATOR	=> DIRECTORY_SEPARATOR.'template'.DIRECTORY_SEPARATOR,
						realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'adm'.DIRECTORY_SEPARATOR	=> DIRECTORY_SEPARATOR,
					);
					$e = array();
					$addt = '';
					foreach ( $dirs as $dir => $subdir )
					{
						$gs = @glob($dir.'*');
						if ( !is_array($gs) ) continue;
						foreach ( $gs as $g )
						{
							if ( !is_dir($g) ) continue;
							$gf = @glob($g.$subdir.'*.html');
							if ( !is_array($gf) ) continue;
							foreach ( $gf as $f )
							{
								if ( is_dir($f) ) continue;
								if ( ($t = file_get_contents($f)) === false ) continue;
								if ( !preg_match_all('/<!--\s*EVENT\s*(.*?)\s*-->/su',$t,$matches) ) continue;
								foreach ( $matches[1] as $match )
								{
									if ( !preg_match('/^[a-z0-9_]+$/',$match) ) continue;
									if ( isset($e[$match]) ) continue;
									$e[$match] = true;
									$spanstyle = '';
									switch ( $match )
									{
										case 'acp_overall_header_head_append':
										case 'overall_header_head_append':
										{
											$spanstyle =
"<!-- IF not S_EXTENDER_SKIP_HIGHLIGHTING -->
<style type=\"text/css\">
span.extender_template_event {
	background-color: navy;
	color: white;
	border: 1px solid gray;
	font-size: small;
	font-family: monospace;
}
</style>
<!-- ENDIF -->
";
											break;
										}
									}
									$addt .= "<!-- EVENT $match -->
$spanstyle<!-- IF not S_EXTENDER_SKIP_HIGHLIGHTING -->
<span class=\"extender_template_event\">$match</span>
<!-- ENDIF -->
<!-- ENDEVENT -->
";
								}
							}
						}
					}

					if ( preg_match_all('/<!--\s*ALLEVENTS\s*-->(.*?)<!--\s*ENDALLEVENTS\s*-->/su',$extender_template,$matches) )
					{
						foreach ( $matches[0] as $match )
						{
							$extender_template = str_replace($match,"<!-- ALLEVENTS -->\n".$addt.'<!-- ENDALLEVENTS -->',$extender_template);
							$addt = '';
						}
					}
					else
					{
						$extender_template .= "\n\n".'<!-- ALLEVENTS -->'.$addt.'<!-- ENDALLEVENTS -->';
					}
					$config_text->set_array(array(
						'extender_template' => htmlspecialchars($extender_template),
					));
				}

				$clear_cache = false;
				$tpls = array();
				
				if ( $extender_config_values['extender_template_on'] && preg_match_all('/<!--\s*EVENT\s*(PRE\s*|)(.*?)\s*-->(.*?)<!--\s*ENDEVENT\s*-->/su',$extender_template,$matches,PREG_OFFSET_CAPTURE) )
				{
					for ( $i=0; $i<count($matches[0]); $i++ )
					{
						$name = $matches[2][$i][0];
						if ( !preg_match('/^[a-z0-9_]+$/',$name) ) continue;
						$name_acp = (strpos($name,'acp_') === 0) ? true : false;
						$varname = 'S_EXTENDER_'.strtoupper($name);
						$listname = '{'.$varname.'}';
						$flen = strlen($listname);
						$listcode ='';
						$list = '';
						$pre = (stripos($matches[1][$i][0],'PRE') === 0) ? true : false;
								
						$realfpath = ($name_acp ? $admpath : $allpath);
						$realfname = $realfpath.$name.'.html';

						switch ( $name )
						{
							case 'acp_overall_footer_after':
							case 'overall_footer_body_after':
							{
								$list = '<!-- IF not S_EXTENDER_SKIP_LISTING -->{S_EXTENDER_LISTING}<!-- ENDIF --><!-- IF not S_EXTENDER_SKIP_CODEMIRROR -->{S_EXTENDER_CODEMIRROR}<!-- ENDIF -->';
								$flen += strlen($list);
							}
							default:
							{
								if ( !$pre )
								{
									$listcode = $matches[3][$i][0];
									$flen += strlen($listcode);
								}
								break;
							}
						}
						if ( !isset($tpls[$name]) )
						{
							if ( !file_exists($realfname) )
							{
								$fsize = -1;
							}
							else
							{
								$fsize = filesize($realfname);
							}
							$tpls[$name] = array(
								'realfpath'		=> $realfpath,
								'realfname'		=> $realfname,
								'fsize'			=> $fsize,
								'listname'		=> $listname,
								'list'			=> $list,
								'acp'			=> $name_acp,

								'listcode'		=> $listcode,
								'flen'			=> $flen,
							);
						}
						else
						{
							$tpls[$name]['listcode'] .= $listcode;
							$tpls[$name]['flen'] += strlen($listcode);
						}
					}
				}

				$list = '<!-- IF not S_EXTENDER_SKIP_LISTING -->{S_EXTENDER_LISTING}<!-- ENDIF --><!-- IF not S_EXTENDER_SKIP_CODEMIRROR -->{S_EXTENDER_CODEMIRROR}<!-- ENDIF -->';
				if ( !isset($tpls['acp_overall_footer_after']) )
				{
					$tpls['acp_overall_footer_after'] = array(
						'realfname'	=> $admpath.'acp_overall_footer_after.html',
						'listcode'	=> '',
						'flen'		=> strlen($list),
						'listname'	=> '',
						'list'		=> $list,
					);
				}
				if ( !isset($tpls['overall_footer_body_after']) )
				{
					$tpls['overall_footer_body_after'] = array(
						'realfname'	=> $allpath.'overall_footer_body_after.html',
						'listcode'	=> '',
						'flen'		=> strlen($list),
						'listname'	=> '',
						'list'		=> $list,
					);
				}

				foreach ( $tpls as $tpl )
				{
					if ( !file_exists($tpl['realfname'])
					  || !empty($tpl['listcode'])
					  || ($tpl['flen'] != filesize($tpl['realfname']))
					)
					{
						$clear_cache = true;
						if ( @file_put_contents($tpl['realfname'],$tpl['listname'].$tpl['listcode'].$tpl['list']) === false )
						{
							$error[] = $user->lang('ACP_EXTENDER_ERROR_WRITE_FILE').$tpl['realfname'];
						}
					}
				}

				$gadm = @glob($admpath.'*.html');
				$gall = @glob($allpath.'*.html');
				if ( is_array($gadm) )
				{
					foreach ( $gadm as $g )
					{
						$name = str_replace('.html','',basename($g));
						if ( !isset($tpls[$name])
						  && ($name != 'acp_overall_footer_after')
						)
						{
							$clear_cache = true;
							unlink($admpath.$name.'.html');
						}
					}
				}
				if ( is_array($gall) )
				{
					foreach ( $gall as $g )
					{
						$name = str_replace('.html','',basename($g));
						if ( !isset($tpls[$name])
						  && ($name != 'overall_footer_body_after')
						)
						{
							$clear_cache = true;
							unlink($allpath.$name.'.html');
						}
					}
				}

				if ( $clear_cache && $this->cache )
				{
					$this->cache->purge();
				}

			}

			$template->assign_vars(array(
				'S_EXTENDER_SKIP_LISTING'		=> true,
				'S_EXTENDER_SKIP_HIGHLIGHTING'	=> true,
			));

			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		$new_config = array_merge($extender_config_text_values,$extender_config_values);

		$this->page_title = $display_vars['title'];
		
		$template->assign_vars(array(
			'L_TITLE'				=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'		=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
			'L_TITLE_DESCRIPTION'	=> $user->lang[$display_vars['title'] . '_DESCRIPTION'],

			'S_ERROR'			=> (sizeof($error)) ? true : false,
			'ERROR_MSG'			=> implode('<br />', $error),

			'S_EXTENDER_SKIP_LISTING'		=> true,
			'S_EXTENDER_SKIP_HIGHLIGHTING'	=> true,

			'S_EXTENDER_SKIP_CODEMIRROR'	=> $extender_config_values['extender_codemirror'] ? false : true,
			'S_EXTENDER_CM_PATH'			=> $extender_config_values['extender_cm_path'],
			'S_EXTENDER_CODEMIRROR'			=> str_replace(
						array(
							'{S_EXTENDER_CM_PATH}',
							'{ACP_EXTENDER_CM_BUTTON}',
						),
						array(
							$extender_config_values['extender_cm_path'],
							$user->lang['ACP_EXTENDER_CM_BUTTON'],
						),
						htmlspecialchars_decode($extender_config_text_values['extender_cm_script'])
					),
		));
		
		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$l_description = (isset($user->lang[$vars['lang'] . '_DESCRIPTION'])) ? $user->lang[$vars['lang'] . '_DESCRIPTION'] : '';

			$content = build_cfg_template($type, $config_key, $new_config, $config_key, $vars);

			if (empty($content))
			{
				continue;
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'TITLE_DESCRIPTION'	=> $l_description,
				'CONTENT'		=> $content,
				)
			);

			unset($display_vars['vars'][$config_key]);
		}
	}
}

?>