<?php
/**
*
* @package extender: core and template event listeners constructor
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/
function extender_fatal_error_handler()
{
	if ( function_exists('error_get_last') )
	{
		global $extender_fatal_error_handler_called, $extender_fatal_error_handler_active;

		$error = error_get_last();
		if ( $error && !$extender_fatal_error_handler_called )
		{
			$e_errors = array(
					E_ERROR				=> 'E_ERROR',
					E_WARNING			=> 'E_WARNING',
					E_PARSE				=> 'E_PARSE',
					E_NOTICE			=> 'E_NOTICE',
					E_CORE_ERROR		=> 'E_CORE_ERROR',
					E_CORE_WARNING		=> 'E_CORE_WARNING',
					E_COMPILE_ERROR		=> 'E_COMPILE_ERROR',
					E_COMPILE_WARNING	=> 'E_COMPILE_WARNING',
					E_USER_ERROR		=> 'E_USER_ERROR',
					E_USER_WARNING		=> 'E_USER_WARNING',
					E_USER_NOTICE		=> 'E_USER_NOTICE',
					E_STRICT			=> 'E_STRICT',
					E_RECOVERABLE_ERROR	=> 'E_RECOVERABLE_ERROR',
					E_DEPRECATED		=> 'E_DEPRECATED',
					E_USER_DEPRECATED	=> 'E_USER_DEPRECATED',
			);

			$listing_spre = "<div width=\"100%\" style=\"background-color:white; padding:10px; text-align:left;\"><font color=\"darkred\" face=\"monospace\" size=\"3\"><b>";
			$listing_ssucc = "</b><br />\n</font></div>";
			
			function extender_fatal_error_handler_filter_root_path($path)
			{
				return function_exists('phpbb_filter_root_path') ? phpbb_filter_root_path($path) : $path;
			}

			switch ( $error['type'] )
			{
				case E_ERROR:				// 1
				case E_PARSE:				// 4
				case E_CORE_ERROR:			// 16
				case E_COMPILE_ERROR:		// 64
				case E_USER_ERROR:			// 256
				case E_RECOVERABLE_ERROR:	// 4096
				{
					if ( !$extender_fatal_error_handler_active )
					{
						if ( !headers_sent() ) @header( 'Content-type: text/html; charset=utf-8' );
						echo '<!DOCTYPE html><html dir="ltr" lang="ru"><head><meta charset="utf-8" /></head><body>'
							.$listing_spre
							.'Extender detect FATAL error ['
							.$e_errors[$error['type']]
							.' = '
							.$error['type'].']: '
							.$error['message']
							.' at file '
							.extender_fatal_error_handler_filter_root_path($error['file'])
							.'('
							.$error['line']
							.')'
							.$listing_ssucc
							.'</body></html>';
					}
					break;
				}
				default:
				{
				    break;
				}
			}
		}
		$extender_fatal_error_handler_called = true;
	}
}

register_shutdown_function('extender_fatal_error_handler');

$extender_fatal_error_handler_called = false;
$extender_fatal_error_handler_active = false;

?>
