<?php
/**
*
* extender [English]
*
* @package extender: core and template event listeners constructor
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

$lang = array_merge($lang, array(
	'ACP_EXTENDER'						=> 'Core and Template event listeners constructor',
	'ACP_EXTENDER_EXPLAIN'				=> 'Changing settings',

	'ACP_EXTENDER_LOCKED'				=> 'Fatal PHP error detected, Extender locked. See debug information. Extedner should be unlocked after this form submit. Lock file(s): ',
	'ACP_EXTENDER_UNLOCKED'				=> 'Extender unlocked.',
	'ACP_EXTENDER_ERROR_WRITE_FILE'		=> 'Error write file: ',
	'ACP_EXTENDER_CM_BUTTON'			=> 'Fullscreen editor',

	'ACP_EXTENDER_DESCRIPTION'			=> 'The extension add core and template event listeners for Your own extension construction.',

	'ACP_EXTENDER_CORE_CONSTRUCTOR'		=> 'Core event listeners',
	'ACP_EXTENDER_CORE_ON'				=> 'Switch ON',
	'ACP_EXTENDER_CORE_ON_EXPLAIN'		=> '',
	'ACP_EXTENDER_CORE'					=> 'PHP code',
	'ACP_EXTENDER_CORE_EXPLAIN'			=> '<br />
Usage:<br />
<i>&lt;!-- EVENT [Priority] PHP_Event[, PHP_Event[, HP_Event]] --&gt;<br />
PHP-code <br />
&lt;!-- ENDEVENT --&gt;</i><br />
Where:<br />
&nbsp;&bull;&nbsp;<i>Priority</i> - priority (greater value is greater priority, negative value is low priority, 0 default);<br />
&nbsp;&bull;&nbsp;<i>PHP_Event</i> - core event identificator (see <a href="https://wiki.phpbb.com/Event_List" target="_blank">phpBB Wiki: Event List</a>).<br />
<br />
All text outside <i>EVENT</i> block is comment.<br />
<br />
Example:<br />
<i>&lt;!-- EVENT core.page_footer_after --&gt;<br />
$this->rootref[\'SITE_LOGO_IMG\'] = \'&lt;img src="http://mysite.ru/forum/styles/prosilver/site-logo.gif" style="max-width: 100%; height:auto; width:auto;"&gt;\';<br />
&lt;!-- ENDEVENT --&gt;</i>',

	'ACP_EXTENDER_TEMPLATE_CONSTRUCTOR'	=> 'Template event listeners',
	'ACP_EXTENDER_TEMPLATE_ON'			=> 'Switch ON',
	'ACP_EXTENDER_TEMPLATE_ON_EXPLAIN'	=> '',
	'ACP_EXTENDER_TEMPLATE'				=> 'HTML, JavaScript, CSS, PHP and other code',
	'ACP_EXTENDER_TEMPLATE_EXPLAIN'		=> '<br />
Usage:<br />
<i>&lt;!-- EVENT [PRE] Template_Event --&gt;<br />
any code<br />
&lt;!-- ENDEVENT --&gt;</i><br />
Whee:<br />
&nbsp;&bull;&nbsp;<i>[PRE]</i> - prefix for compile template before phpBB core; if omitted, phpBB core should compile template;<br />
&nbsp;&bull;&nbsp;<i>Template_Event</i> - template event identificator (see <a href="https://wiki.phpbb.com/Event_List#Template_Events" target="_blank">phpBB Wiki: Event List: Template Events</a> and <a href="https://wiki.phpbb.com/Event_List#ACP_Template_Events" target="_blank">phpBB Wiki: Event List: ACP Template Events</a>).<br />
<br />
Any text outside <i>EVENT</i> block is comment.<br />
<br />
Examples:<br />
<i>&lt;!-- EVENT PRE overall_header_stylesheets_after --&gt;<br />
any code here<br />
&lt;!-- ENDEVENT --&gt;</i><br />
<i>&lt;!-- EVENT overall_footer_body_after --&gt;<br />
any code here<br />
&lt;!-- ENDEVENT --&gt;</i><br />
<br />
Inside <i>EVENT</i> block use:<br />
&nbsp;&bull;&nbsp;for JavaScript <i>&lt;script type="text/javascript"&gt;...&lt;/script&gt;</i><br />
&nbsp;&bull;&nbsp;for StyleSheet <i>&lt;style type="text/css"&gt;...&lt;/style&gt;</i><br />
&nbsp;&bull;&nbsp;for PHP <i>&lt;!-- PHP --&gt; PHP-code &lt;!-- ENDPHP --&gt;</i><br />
<br />
In events with prefix <i>PRE</i> allowable all phpBB 3.0.13 templates constructions (except INCLUDE, etc.), PHP-code execution is unconditional.<br />
<br />
In events without prefix <i>PRE</i> allowable all phpBB 3.1 templates constructions, PHP-code execute only if PHP in templates allowed.<br />
<br />
Outside PHP-code Your can use:<br />
&nbsp;&bull;&nbsp;Any language string present in your language/ directory like this: {L_<em>&lt;STRINGNAME&gt;</em>} where <em>&lt;STRINGNAME&gt;</em> is the name of the translated string you want to add. For example, {L_WROTE} will be displayed as “wrote” or its translation according to user’s locale.<br />
&nbsp;&bull;&nbsp;Root definitions at template, for example {SCRIPT_NAME}. For local varyables, defined by DEFINE operator, use {$VARNAME}.<br />
<br />
For developers: to highlite all Template Events at all pages for all users (not for this extension page in ACP) add empty block at the end of window<br />
<i>&lt;!-- ALLEVENTS --&gt;<br />
&lt;!-- ENDALLEVENTS --&gt;</i><br />
Do not forget to delete <i>ALLEVENTS</i> block with all contents after pages viewing.',

	'ACP_EXTENDER_MODES'				=> 'Modes',
	'ACP_EXTENDER_DEBUG'				=> 'Switch ON debug mode (if errors found)',
	'ACP_EXTENDER_DEBUG_EXPLAIN'		=> 'If errors found, Your can see compiler messages and listing of compiled code at the page bottom.',
	'ACP_EXTENDER_DEBUG_WARNINGS'		=> 'Switch ON warnings in debug mode',
	'ACP_EXTENDER_DEBUG_WARNINGS_EXPLAIN'	=> 'For E_NOTICE | E_WARNING | E_DEPRECATED | E_STRICT | E_USER_DEPRECATED | E_USER_WARNING | E_USER_NOTICE',
	
	'ACP_EXTENDER_EDITOR'				=> 'Editor',
	'ACP_EXTENDER_CODEMIRROR'			=> 'Use CodeMirror',
	'ACP_EXTENDER_CODEMIRROR_EXPLAIN'	=> '',
	'ACP_EXTENDER_CM_PATH'				=> 'Path to CodeMirror',
	'ACP_EXTENDER_CM_PATH_EXPLAIN'		=> 'URL or local address without slash at the end.',
	'ACP_EXTENDER_CM_SCRIPT'			=> 'JavaScript for CodeMirror loading and tuning',
	'ACP_EXTENDER_CM_SCRIPT_EXPLAIN'	=> 'Change code, if it`s nessesary.<br />
<br />
<a href="http://codemirror.net/" target="_blank">CodeMirror</a> is a versatile text editor. Hints:<br />
&nbsp;&bull;&nbsp;send empty code to restore default script;<br />
&nbsp;&bull;&nbsp;it is posible to use in script only substitutions below:<br />
<i>{S_EXTENDER_CM_PATH}</i> - path to CodeMirror;<br />
<i>{ACP_EXTENDER_CM_BUTTON}</i> - editor button text;<br />
&nbsp;&bull;&nbsp;use a button above code window for CodeMirror fullscreen edit, press Esc or F11 for return;<br />
&nbsp;&bull;&nbsp;PHP sintax highlights for core events, for highlight event blocks delimiters use comments:<br />
<i>//&lt;!-- EVENT [Priority] PHP_Event[, PHP_Event[, HP_Event]] --&gt;<br />
PHP-code <br />
//&lt;!-- ENDEVENT --&gt;</i><br />
&nbsp;&bull;&nbsp;mixed HTML, CSS, JavaScript sintax highlights for template events.',

	'ACP_EXTENDER_PHP_TITLE'			=> 'PHP in core events and template events with prefix <i>PRE</i>',
	'ACP_EXTENDER_PHP_EXPLAIN'			=> '<br />
Your can use:<br />
&nbsp;&bull;&nbsp;<i>$this->event[]</i> for event data<br />
&nbsp;&bull;&nbsp;<i>$this->rootref[]</i> for rootref<br />
&nbsp;&bull;&nbsp;<i>$this->tpldata[]</i> for tamplate<br />
&nbsp;&bull;&nbsp;<i>$this->userlang[]</i> for user language vars<br />
&nbsp;&bull;&nbsp;etc., see extension source codes.<br />
<br />
All local vars, defiuned in already processed events, accessible in new events.<br />
<br />
If PHP fatal erorrs occured, Your can see error message at screen and unconditionally listiong of compiled code, after this extension should be locked and can be unlocked after lock file(s) at system temp dir deletion.<br />
<br />
If extension locked and debug information switched on, at the page bottom Your can see listiong and lock message.<br />
<br >
If PHP fatal error occured outside extension code, instead of blank page Your can see error info and extension not locked.',

	'LOG_EXTENDER_FATAL_ERROR' => '<strong>Extender: FATAL error found%s',

	'ACP_EXTENDER_DIRECTORY_NOT_WRITABLE'	=> 'Path “%s” is not writable. To use this extension you must set the rights.',
	'ACP_EXTENDER_FILE_NOT_WRITABLE'		=> 'File “%s” is not writable. To use this extension you must set the rights.',
));
