<?php
/**
*
* extender [Russian]
*
* @package extender: core and template event listeners constructor
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

$lang = array_merge($lang, array(
	'ACP_EXTENDER'						=> 'Конструктор слушателей событий ядра и шаблонов',
	'ACP_EXTENDER_EXPLAIN'				=> 'Изменение настроек',

	'ACP_EXTENDER_LOCKED'				=> 'Работа расширения заблокирована в связи с фатальной ошибкой PHP, см. отладочную информацию. Разблокировка произойдёт после отправки изменения настроек расширения. Файл(ы) блокировки: ',
	'ACP_EXTENDER_UNLOCKED'				=> 'Расширение разблокировано.',
	'ACP_EXTENDER_ERROR_WRITE_FILE'		=> 'Ошибка записи файла: ',
	'ACP_EXTENDER_CM_BUTTON'			=> 'Редактировать в полноэкранном режиме',

	'ACP_EXTENDER_DESCRIPTION'			=> 'Расширение позволяет добавлять слушателей событий ядра и шаблонов, в результате Вы можете конструировать собственные расширения без необходимости создания их файлов в соответствии с правилами phpBB.',

	'ACP_EXTENDER_CORE_CONSTRUCTOR'		=> 'Слушатели событий ядра',
	'ACP_EXTENDER_CORE_ON'				=> 'Включить',
	'ACP_EXTENDER_CORE_ON_EXPLAIN'		=> '',
	'ACP_EXTENDER_CORE'					=> 'Код PHP',
	'ACP_EXTENDER_CORE_EXPLAIN'			=> '<br />
Использование:<br />
<i>&lt;!-- EVENT [Priority] PHP_Event[, PHP_Event[, HP_Event]] --&gt;<br />
PHP-код <br />
&lt;!-- ENDEVENT --&gt;</i><br />
Где:<br />
&nbsp;&bull;&nbsp;<i>Priority</i> - приоритет (чем больше число, тем больше приоритет обработчика события, чем больше по модулю отрицательное число, тем меньше приоритет, по умолчанию 0);<br />
&nbsp;&bull;&nbsp;<i>PHP_Event</i> - идентификатор события ядра (см. <a href="https://wiki.phpbb.com/Event_List" target="_blank">phpBB Wiki: Event List</a>).<br />
<br />
Любой текст вне блока <i>EVENT</i> рассматривается как комментарий и не обрабатывается.<br />
<br />
Пример:<br />
<i>&lt;!-- EVENT core.page_footer_after --&gt;<br />
$this->rootref[\'SITE_LOGO_IMG\'] = \'&lt;img src="http://mysite.ru/forum/styles/prosilver/site-logo.gif" style="max-width: 100%; height:auto; width:auto;"&gt;\';<br />
&lt;!-- ENDEVENT --&gt;</i>',

	'ACP_EXTENDER_TEMPLATE_CONSTRUCTOR'	=> 'Слушатели событий шаблонов',
	'ACP_EXTENDER_TEMPLATE_ON'			=> 'Включить',
	'ACP_EXTENDER_TEMPLATE_ON_EXPLAIN'	=> '',
	'ACP_EXTENDER_TEMPLATE'				=> 'Код HTML, JavaScript, CSS, PHP и др.',
	'ACP_EXTENDER_TEMPLATE_EXPLAIN'		=> '<br />
Использование:<br />
<i>&lt;!-- EVENT [PRE] Template_Event --&gt;<br />
здесь какой-либо код<br />
&lt;!-- ENDEVENT --&gt;</i><br />
Где:<br />
&nbsp;&bull;&nbsp;<i>[PRE]</i> - префикс, указывающий на необходимость компиляции шаблона для события перед обработкой шаблона ядром; если префикс опущен, компиляция выполняется ядром phpBB;<br />
&nbsp;&bull;&nbsp;<i>Template_Event</i> - идентификатор события шаблона (см. <a href="https://wiki.phpbb.com/Event_List#Template_Events" target="_blank">phpBB Wiki: Event List: Template Events</a> и <a href="https://wiki.phpbb.com/Event_List#ACP_Template_Events" target="_blank">phpBB Wiki: Event List: ACP Template Events</a>).<br />
<br />
Любой текст вне блока <i>EVENT</i> рассматривается как комментарий и не обрабатывается.<br />
<br />
Примеры использования:<br />
<i>&lt;!-- EVENT PRE overall_header_stylesheets_after --&gt;<br />
здесь какой-либо код<br />
&lt;!-- ENDEVENT --&gt;</i><br />
<i>&lt;!-- EVENT overall_footer_body_after --&gt;<br />
здесь какой-либо код<br />
&lt;!-- ENDEVENT --&gt;</i><br />
<br />
Внутри блока <i>EVENT</i> используйте:<br />
&nbsp;&bull;&nbsp;для JavaScript <i>&lt;script type="text/javascript"&gt;...&lt;/script&gt;</i><br />
&nbsp;&bull;&nbsp;для StyleSheet <i>&lt;style type="text/css"&gt;...&lt;/style&gt;</i><br />
&nbsp;&bull;&nbsp;для PHP <i>&lt;!-- PHP --&gt; PHP-код &lt;!-- ENDPHP --&gt;</i><br />
<br />
В событиях с префиксом <i>PRE</i> допустимы все конструкции для шаблонов phpBB 3.0.13 (кроме включений файлов, например, INCLUDE и т.п.), код PHP выполняется безусловно.<br />
<br />
В событиях без префикса <i>PRE</i> допустимы все конструкции для шаблонов phpBB 3.1, код PHP выполняется только при условии разрешения PHP в шаблонах.<br />
<br />
Вне кода PHP можно использовать:<br />
&nbsp;&bull;&nbsp;любые языковые переменные из языковых файлов (например, {L_<em>&lt;STRINGNAME&gt;</em>}, где <em>&lt;STRINGNAME&gt;</em> — это имя переведённой строки); так, {L_WROTE} будет отображено как «wrote» или переведено в зависимости от выбранного пользователем языка<br />
&nbsp;&bull;&nbsp;любые переменные, определённые для основного шаблона, например, {SCRIPT_NAME}; для локальных переменных, определённых посредством DEFINE, используйте {$VARNAME}.<br />
<br />
Для разработчиков: для подсветки всех событий шаблонов на всех страницах для любого пользователя (на страницу настройки этого расширения в панели администратора опция не распространяется) достаточно добавить в конец текста окна<br />
<i>&lt;!-- ALLEVENTS --&gt;<br />
&lt;!-- ENDALLEVENTS --&gt;</i><br />
Не забудьте удалить блок <i>ALLEVENTS</i> вместе с автоматически добавленным в него содержимым после завершения поиска нужного события.',

	'ACP_EXTENDER_MODES'				=> 'Режимы работы',
	'ACP_EXTENDER_DEBUG'				=> 'Включить выдачу отладочной информации при обнаружении ошибок',
	'ACP_EXTENDER_DEBUG_EXPLAIN'		=> 'При наличии ошибок внизу страницы появится сообщение компилятора и листинг скомпилированного кода.',
	'ACP_EXTENDER_DEBUG_WARNINGS'		=> 'Включить предупреждения в выдачу отладочной информации',
	'ACP_EXTENDER_DEBUG_WARNINGS_EXPLAIN'	=> 'Листинг выдаётся при наличии E_NOTICE | E_WARNING | E_DEPRECATED | E_STRICT | E_USER_DEPRECATED | E_USER_WARNING | E_USER_NOTICE',
	
	'ACP_EXTENDER_EDITOR'				=> 'Редактор',
	'ACP_EXTENDER_CODEMIRROR'			=> 'Использовать CodeMirror',
	'ACP_EXTENDER_CODEMIRROR_EXPLAIN'	=> '',
	'ACP_EXTENDER_CM_PATH'				=> 'Путь к CodeMirror',
	'ACP_EXTENDER_CM_PATH_EXPLAIN'		=> 'Адрес в сети интернет или локальный без слэша в конце.',
	'ACP_EXTENDER_CM_SCRIPT'			=> 'JavaScript загрузки и настройки CodeMirror',
	'ACP_EXTENDER_CM_SCRIPT_EXPLAIN'	=> 'При необходимости измените источник загрузки и настройки, однако, при смене версии расширения измененные Вами данные могут быть заменены значениями по умолчанию.<br />
<br />
<a href="http://codemirror.net/" target="_blank">CodeMirror</a> - это универсальный редактор. Подсказки:<br />
&nbsp;&bull;&nbsp;для восстановления умолчания скрипта запуска отправьте пустой код в окне редактирования;<br />
&nbsp;&bull;&nbsp;в скрипте допустимо использование только следующих подстановок:<br />
<i>{S_EXTENDER_CM_PATH}</i> - путь к CodeMirror;<br />
<i>{ACP_EXTENDER_CM_BUTTON}</i> - надпись на кнопке вызова редактора;<br />
&nbsp;&bull;&nbsp;для перехода в редактор CodeMirror режим нажмите кнопку над окном редактирования, для возврата - F11 или Esc;<br />
&nbsp;&bull;&nbsp;для событий ядра подсвечивается синтаксис PHP, чтобы подсвечивались ограничители блоков событий перед ними можно поставить символы комментария:<br />
<i>//&lt;!-- EVENT [Priority] PHP_Event[, PHP_Event[, HP_Event]] --&gt;<br />
PHP-код <br />
//&lt;!-- ENDEVENT --&gt;</i><br />
&nbsp;&bull;&nbsp;для событий шаблонов подсвечивается смешанный синтаксис HTML, CSS, JavaScript.',

	'ACP_EXTENDER_PHP_TITLE'			=> 'PHP в слушателях событий ядра и шаблонов с префиксом <i>PRE</i>',
	'ACP_EXTENDER_PHP_EXPLAIN'			=> '<br />
Вы можете использовать:<br />
&nbsp;&bull;&nbsp;<i>$this->event[]</i> для доступа к данным события<br />
&nbsp;&bull;&nbsp;<i>$this->rootref[]</i> для доступа к переменным общего шаблона<br />
&nbsp;&bull;&nbsp;<i>$this->tpldata[]</i> для доступа к переменным шаблона<br />
&nbsp;&bull;&nbsp;<i>$this->userlang[]</i> для доступа к языковым переменным<br />
&nbsp;&bull;&nbsp;и др., см. исходный код расширения.<br />
<br />
Все локальные переменные, определённые в уже обработанных событиях, доступны в новых событиях.<br />
<br />
При возникновении фатальных ошибок PHP на экран выдаётся сообщение об ошибке и безусловно листинг скомпилированного кода, после чего выполнение расширения блокируется до удаления блокирующего файла в системном каталоге временных файлов.<br />
<br />
При наличии блокировки и включенном режиме выдачи отладочной информации внизу экрана выдаётся листинг и сообщение о блокировке.<br />
<br >
Если фатальная ошибка произошла вне кода расширения, вместо пустой страницы выдаётся информация об ошибке, расширение не блокируется.<br />
<br />
Для справки - коды ошибок, безусловно (*) или при определённых условиях (**) являющихся фатальными (условия отличаются от представленных в руководствах по PHP, поскольку в расширении для исполнения кода используется функция eval() с дополнительным обрамлением):<br />
&nbsp;&bull;&nbsp;[<i>E_ERROR</i> = 1] (*) Фатальные ошибки времени выполнения. Это неустранимые средствами самого скрипта ошибки, такие как ошибка распределения памяти и т.п. Выполнение скрипта в таком случае прекращается.<br />
&nbsp;&bull;&nbsp;[<i>E_PARSE</i> = 4] (**) Ошибки на этапе компиляции. Должны генерироваться только парсером.<br />
&nbsp;&bull;&nbsp;[<i>E_CORE_ERROR</i> = 16] (*) Фатальные ошибки, которые происходят во время запуска РНР. Такие ошибки схожи с E_ERROR, за исключением того, что они генерируются ядром PHP.<br />
&nbsp;&bull;&nbsp;[<i>E_COMPILE_ERROR</i> = 64] (**) Фатальные ошибки на этапе компиляции. Такие ошибки схожи с E_ERROR, за исключением того, что они генерируются скриптовым движком Zend.<br />
&nbsp;&bull;&nbsp;[<i>E_USER_ERROR</i> = 256] (**) Сообщения об ошибках сгенерированные пользователем. Такие ошибки схожи с E_ERROR, за исключением того, что они генерируются в коде скрипта средствами функции PHP trigger_error().<br />
&nbsp;&bull;&nbsp;[<i>E_RECOVERABLE_ERRO</i>R = 4096] (**) Фатальные ошибки с возможностью обработки. Такие ошибки указывают, что, вероятно, возникла опасная ситуация, но при этом, скриптовый движок остается в стабильном состоянии. Если такая ошибка не обрабатывается функцией, определенной пользователем для обработки ошибок (см. set_error_handler()), выполнение приложения прерывается, как происходит при ошибках E_ERROR. Начиная с PHP 5.2.0<br />
<br />
Все сообщения о фатальных ошибках либо в листинге выдаются на английском языке в связи с возможными ошибками заголовка страницы.',

	'LOG_EXTENDER_FATAL_ERROR' => '<strong>Extender: обнаружена фатальная ошибка%s',

	'ACP_EXTENDER_DIRECTORY_NOT_WRITABLE'	=> 'Запись в каталог «%s» запрещена. Для работы расширения необходимо установить права на запись.',
	'ACP_EXTENDER_FILE_NOT_WRITABLE'		=> 'Запись в файл «%s» запрещена. Для работы расширения необходимо установить права на запись.',
));
