<?php
/**
*
* @package extender: core and template event listeners constructor
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\extender\migrations\v0xx;

class extender_v_0_1_0 extends \phpbb\db\migration\migration
{
	public function effectively_installed()
	{
		return isset($this->config['extender_version']) && version_compare($this->config['extender_version'], '0.1.0', '>=');
	}

	static public function depends_on()
	{
		return array(
			'\phpbb\db\migration\data\v310\dev'
		);
	}

	public function update_schema()
	{
		return array(
		);
	}

	public function revert_schema()
	{
		return array(
		);
	}

	public function update_data()
	{
		return array(
			// Current version
			array('config.add', array('extender_version', '0.1.0')),

			// Add configs
			array('config.add', array('extender_core_on', '0')),
			array('config_text.add', array('extender_core', '')),

			array('config.add', array('extender_template_on', '0')),
			array('config_text.add', array('extender_template', '')),

			array('config.add', array('extender_debug', '1')),

			// Add ACP modules
			array('module.add', array('acp', 'ACP_CAT_DOT_MODS', 'ACP_EXTENDER')),
			array('module.add', array('acp', 'ACP_EXTENDER', array(
					'module_basename'	=> '\c61\extender\acp\extender_module',
					'module_langname'	=> 'ACP_EXTENDER_EXPLAIN',
					'module_mode'		=> 'config_extender',
					'module_auth'		=> 'acl_a_extender',
			))),
			
			// Add permissions
			array('permission.add', array('a_extender', true)),

			// Set permissions
			array('permission.permission_set', array('ROLE_ADMIN_FULL', 'a_extender')),
		);
	}

}