<?php
/**
*
* @package extender: core and template event listeners constructor
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\extender\migrations\v0xx;

class extender_v_0_1_7 extends \phpbb\db\migration\migration
{
	public function effectively_installed()
	{
		return isset($this->config['extender_version']) && version_compare($this->config['extender_version'], '0.1.7', '>=');
	}

	static public function depends_on()
	{
		return array(
			'\c61\extender\migrations\v0xx\extender_v_0_1_6'
		);
	}

	public function update_schema()
	{
		return array(
		);
	}

	public function revert_schema()
	{
		return array(
		);
	}

	public function update_data()
	{
		return array(
			// Update existing configs

			// Current version
			array('config.update', array('extender_version', '0.1.7')),

			// Add configs
			array('config.add', array('extender_codemirror', '0')),
			array('config_text.add', array('extender_cm_script', 
'
<script type="text/javascript">
// <![CDATA[
function extender_CSSLoad(file){
	var link = document.createElement("link");
	link.setAttribute("rel", "stylesheet");
	link.setAttribute("type", "text/css");
	link.setAttribute("href", file);
	document.getElementsByTagName("head")[0].appendChild(link)
}
extender_CSSLoad("http://codemirror.net/lib/codemirror.css");
extender_CSSLoad("http://codemirror.net/addon/display/fullscreen.css");
// ]]>
</script>

<script type="text/javascript" src="http://codemirror.net/lib/codemirror.js"></script>
<script type="text/javascript" src="http://codemirror.net/addon/edit/matchbrackets.js"></script>
<script type="text/javascript" src="http://codemirror.net/addon/display/fullscreen.js"></script>
<script type="text/javascript" src="http://codemirror.net/mode/htmlmixed/htmlmixed.js"></script>
<script type="text/javascript" src="http://codemirror.net/mode/xml/xml.js"></script>
<script type="text/javascript" src="http://codemirror.net/mode/javascript/javascript.js"></script>
<script type="text/javascript" src="http://codemirror.net/mode/css/css.js"></script>
<script type="text/javascript" src="http://codemirror.net/mode/clike/clike.js"></script>
<script type="text/javascript" src="http://codemirror.net/mode/php/php.js"></script>

<script type="text/javascript">
// <![CDATA[
var extender_core_editor = CodeMirror.fromTextArea(document.getElementById("extender_core"), {
	mode: "text/x-php",
	lineNumbers: true,
	lineWrapping: false,
	matchBrackets: true,
	autofocus: false,
	extraKeys: {
		"F11": function(cm) {
			cm.setOption("fullScreen", !cm.getOption("fullScreen"));
		},
		"Esc": function(cm) {
			if (cm.getOption("fullScreen")) cm.setOption("fullScreen", false);
		}
	}
});
var extender_template_editor = CodeMirror.fromTextArea(document.getElementById("extender_template"), {
	lineNumbers: true,
	lineWrapping: false,
	matchBrackets: true,
	autofocus: false,
	extraKeys: {
		"F11": function(cm) {
			cm.setOption("fullScreen", !cm.getOption("fullScreen"));
		},
		"Esc": function(cm) {
			if (cm.getOption("fullScreen")) cm.setOption("fullScreen", false);
		}
	}
});
var extender_cm_script_editor = CodeMirror.fromTextArea(document.getElementById("extender_cm_script"), {
	lineNumbers: true,
	lineWrapping: false,
	matchBrackets: true,
	autofocus: false,
	extraKeys: {
		"F11": function(cm) {
			cm.setOption("fullScreen", !cm.getOption("fullScreen"));
		},
		"Esc": function(cm) {
			if (cm.getOption("fullScreen")) cm.setOption("fullScreen", false);
		}
	}
});
extender_core_editor.setSize(null,Math.floor(0.8*screen.height));
extender_template_editor.setSize(null,Math.floor(0.8*screen.height));
extender_cm_script_editor.setSize(null,200);
// ]]>
</script>
')),
		);
	}

}